<?php
/* 
   MasterSoft Software Solutions Ltd. - www.mastersoft.at - October. 2009 
   info@mastersoft.at
   This file is licensed under terms of the MPT Open License.
   You can find the license under http://www.mastersoft.at/content/view/26/34/lang,de/    
*/

// no direct access
defined('_JEXEC') or die('Restricted access');

/**
 * the controller class for video
 * @author <a href="http://www.mastersoft.at" target="_blank">MasterSoft Software Solutions Ltd.</a>
 *
 */
class VideosControllerVideo extends VideosController
{
	/**
	 * constructor (registers additional tasks to methods)
	 * @return void
	 */
	function __construct()
	{
		parent::__construct();

		// Register Extra tasks		
		$this->registerTask( 'add', 'edit' );
		$this->registerTask( 'unpublish','publish');
		$this->registerTask( 'saveorder','saveorder');				
	}

	/**
	 * display the edit form
	 * @return void
	 */
	function edit()
	{		
		JRequest::setVar( 'view', 'video' );
		JRequest::setVar( 'layout', 'form'  );
		JRequest::setVar('hidemainmenu', 1);

		parent::display();
	}

	/**
	 * save a record (and redirect to main page)
	 * @return void
	 */
	function save()
	{
		$model = $this->getModel('video');
		
		$msg = $model->store();		

		// Check the table in so it can be edited.... we are done with it anyway
		$link = 'index.php?option=com_mastersoftVideoPlayer';
		$this->setRedirect($link, $msg);
	}

	/**
	 * remove record(s)
	 * @return void
	 */
	function remove()
	{
		$model = $this->getModel('video');
		
		$msg = $model->delete();
		$this->setRedirect( 'index.php?option=com_masterSoftVideoPlayer', $msg );
	}

	
	/**
	* Publishes or Unpublishes one or more records	
	*/
	function publish()
	{
		$this->setRedirect( 'index.php?option=com_masterSoftVideoPlayer' );

		// Initialize variables
		$db			=& JFactory::getDBO();
		$user		=& JFactory::getUser();
		$cid		= JRequest::getVar( 'cid', array(0), 'post', 'array' );
		$task		= JRequest::getCmd( 'task' );
		$publish	= ($task == 'publish');
		$n			= count( $cid );

		if (empty( $cid ))
		{
			return JError::raiseWarning( 500, 'No items selected' );
		}

		JArrayHelper::toInteger( $cid );
		$cids = implode( ',', $cid );

		$query = 'UPDATE #__msVideo'
		. ' SET msv_published = ' . (int) $publish
		. ' WHERE msv_id IN ( '. $cids .' )';
		
		$db->setQuery( $query );
		
		if (!$db->query()) 
		{
			return JError::raiseWarning( 500, $row->getError() );
		}
		$this->setMessage($n  .($publish ? ' items published' : ' items unpublished') );

	}
	
	
	
	/**
	 * cancel editing a record
	 * @return void
	 */
	function cancel()
	{
		$msg = 'Operation canceled';
		$this->setRedirect( 'index.php?option=com_masterSoftVideoPlayer', $msg );
	}

	
	/**
	 * save position of video entry
	 * @return string a success or error message
	 */
	function saveorder()
	{
		$db	= & JFactory::getDBO();
		$posid = JRequest::getVar("posid",0,'post');
		$position = JRequest::getVar("position",0,'post');
		$direction = JRequest::getVar("direction",0,'post');
		
		$nextPos = $position;
		if($direction == "up")
			$nextPos -= 1;
		else
			$nextPos += 1;

		
		$sql = "update #__msVideo set msv_position = " .$position ." where msv_position = " .$nextPos;
		$db->setQuery($sql);
		$db->query();
		
		$sql2 = "update #__msVideo set msv_position = " .$nextPos ." where msv_id = " .$posid;
		$db->setQuery($sql2);
		$db->query();
		
	        
        $msg = "Reihenfolge erfolgreich ge&auml;ndert";
        
        $link = 'index.php?option=com_mastersoftVideoPlayer';
		$this->setRedirect($link, $msg);
	}
}
?>
